require "rss/0.9"

module RSS

	class Rss
		
		class Channel

			%w(generator ttl).each do |x|
				install_text_element(x)
			end

			%w(category).each do |x|
				install_has_child_element(x)
			end

			def other_element(convert, indent='')
				rv = <<-EOT
#{indent}#{category_element(convert)}
#{indent}#{generator_element(convert)}
#{indent}#{ttl_element(convert)}
EOT
				rv << super
			end

			Category = Item::Category

			class Item
			
				%w(pubDate).each do |x|
					install_date_element(x, 'rfc822')
				end

				%w(guid).each do |x|
					install_has_child_element(x)
				end
			
				def other_element(convert, indent='')
					rv = <<-EOT
#{indent}#{pubDate_element(false)}
#{indent}#{guid_element(false)}
EOT
					rv << super
				end

				class Guid < Element
					
					include RSS09

					[
						["isPermaLink", nil, false]
					].each do |name, uri, required|
						install_get_attribute(name, uri, required)
					end

					content_setup

					def initialize(isPermaLink=nil, content=nil)
						super()
						@isPermaLink = isPermaLink
						@content = content
					end

					def to_s(convert=true)
						if @content
							rv = %Q!<guid!
							rv << %Q! isPermaLink="#{h @isPermaLink}"! if @isPermaLink
							rv << %Q!>#{h @content}</guid>!
							rv = @converter.convert(rv) if convert and @converter
							rv
						else
							''
						end
					end

					private
					def _attrs
						[
							["isPermaLink", false]
						]
					end

				end

			end

		end

	end

	if const_defined?(:BaseListener)
		RSS09::ELEMENTS.each do |x|
			BaseListener.install_get_text_element(x, URI, "#{x}=")
		end
	end

end
